-- REG
-- Implementacao de um registrador parametrizavel com clear assíncrono e clock enable
--
entity reg is
	generic
	(
		n	: integer := 8
	);
	port
	(
		clk, clr, en	: in bit;								-- Sinais de Controle
		d					: in bit_vector(n-1 downto 0);	-- Entrada de dados
		q					: out bit_vector(n-1 downto 0)	-- Saida de dados
	);
end reg;

architecture rtl of reg is

begin

--	Implementacao sem FOR GENERATE
--	process(clk, clr, en)
--	begin
--		if (clr = '1') then
--			q <= (others => '0');
--		elsif (en = '1') then
--			if (clk'event and clk = '1') then
--				q <= d;
--			end if;
--		end if;
--	end process;

--	Implementacao com FOR GENERATE
	abc: for i in n-1 downto 0 generate
		d_ffi: work.d_ff
			port map (
				clk => clk,
				clr => clr,
				en => en,
				d => d(i),
				q => q(i)
			);
	end generate abc;

end rtl;
